package MdPacket;

#use lib "/nasA_solar1/home/sbukeis/lib/egse_sw_lib/perllib/EisCcsdsLib";

#use CcsdsInterface;
use strict;

use vars qw(@ISA @EXPORT $VERSION);

use Exporter;
$VERSION = 1.00;
@ISA = qw(Exporter);

@EXPORT = qw();

sub BEGIN {
#    print STDOUT "Ccsds BEGIN\n";
#    $numberOfPackets = 0;
}

sub new {
    my ($class) = shift;
    my $self = {

	_header => MdHeader->new(),
	_data   => "",

    };
    bless $self, $class; 
    return $self;
}

# Don't need methods below...?

sub isFirstExposurePacket {

    return $_[0]->{_header}->isFirstExposurePacket();
}

sub isFirstExposurePacket1 {
    return $_[0]->{_header}->isFirstExposurePacket1();
}

sub isMiddleExposurePacket {
    return $_[0]->{_header}->isMiddleExposurePacket();
}

sub isLastExposurePacket {
    return $_[0]->{_header}->isLastExposurePacket();
}

sub isLastExposurePacket1 {
    return $_[0]->{_header}->isLastExposurePacket();
}

sub isStandAloneExposurePacket {
    return $_[0]->{_header}->isStandaloneExposurePacket();
}

sub sequenceFlags {
    return $_[0]->{_header}->sequenceFlags();
}

sub isEndExposurePacket {
    return $_[0]->{_header}->isEndExposurePacket();
}


sub data_type {
    return $_[0]->{_header}->data_type();
}

sub packetSize {
    return $_[0]->{_header}->packetSize();
}

sub spn {
    return $_[0]->{_header}->spn();
}

sub setSpn {
    $_[0]->{_header}->setSpn($_[1]);
}

sub mid {
    return $_[0]->{_header}->mid();
}

sub mainSequenceFlag {
    return $_[0]->{_header}->mainSequenceFlag();
}

sub setMainSequenceFlag {
    $_[0]->{_header}->setMainSequenceFlag($_[1]);
}

sub mainSequenceCount {
    return $_[0]->{_header}->mainSequenceCOunt();
}

sub setMainSequenceCount {
    $_[0]->{_header}->setMainSequenceCOunt($_[1]);
}

sub ppe {
    return $_[0]->{_header}->ppe();
}

sub imagePerFrame {
    return $_[0]->{_header}->imagePerFrame();
}

sub sid {
    return $_[0]->{_header}->sid();
}

sub setSid {
    $_[0]->{_header}->setSid($_[1]);
}

sub subSequenceFlag {
    return $_[0]->{_header}->subSequenceFlag();
}

sub sstSubSequenceFlag {
    $_[0]->{_header}->setSubSequenceFlag($_[1]);
}

sub subSequenceCount {
    return $_[0]->{_header}->subSequenceCOunt();
}

sub setSubSequenceCount {
    $_[0]->{_header}->setSubSequenceCount($_[1]);
}

sub fx {
    return $_[0]->{_header}->fx();
}

sub setFx {
    $_[0]->{_header}->setFx($_[1]);
}

sub fy {
    return $_[0]->{_header}->fy();
}

sub setFy {
    $_[0]->{_header}->setFy($_[1]);
}

sub px {
    return $_[0]->{_header}->px();
}

sub setPx {
    $_[0]->{_header}->setPx();
}

sub py {
    return $_[0]->{_header}->py();
}

sub setPy {
    $_[0]->{_header}->setPy($_[1]);
}

sub bx {
    return $_[0]->{_header}->bx();
}

sub setBx {
    $_[0]->{_header}->setBx($_[1]);
}

sub by {
    return $_[0]->{_header}->by();
}

sub setBy {
    $_[0]->{_header}->setBy($_[1]);
}

sub bitCompressionMode {
    return $_[0]->{_header}->bitCompressionMode();
}

sub imageCompressionMode {
    return $_[0]->{_header}->imageCompressionMode();
}

sub imageCompressionParameters {
    return $_[0]->{_header}->imageCompressionParameters();
}

sub ti1 {
    return $_[0]->{_header}->ti1();
}

sub setTi1 {
    $_[0]->{_header}->setTi1($_[1]);
}

sub ti2 {
    return $_[0]->{_header}->ti2();
}

sub setTi2 {
    $_[0]->{_header}->setTi1($_[1]);
}

sub mhcDuration {
    return $_[0]->{_header}->mhcDuration();
}

sub exposureDuration {
    return $_[0]->{_header}->exposureDuration();
}

sub sequenceNumber {
    return $_[0]->{_header}->sequenceNumber();
}

sub linelistNumber {
    return $_[0]->{_header}->linelistNumber();
}

sub sequenceId {
    return $_[0]->{_header}->sequenceId();
}

sub rasterId {
    return $_[0]->{_header}->rasterId();
}

sub fineMirrorPosition {
    return $_[0]->{_header}->fineMirrorPosition();
}

sub setFineMirrorPosition {
    $_[0]->{_header}->setFineMirrorPosition($_[1]);
}

sub exposuresRequird {
    return $_[0]->{_header}->exposuresRequired();
}

sub exposuresPerformed {
    return $_[0]->{_header}->exposuresPerformaed();
}

sub setExposuresPerformed {
    $_[0]->{_header}->setExposuresPerformed($_[1]);
}

sub rasterRepeatsRequird {
    return $_[0]->{_header}->rasterRepeatsRequired();
}

sub rasterRepeatsPerformed {
    return $_[0]->{_header}->rasterRepeatsPerformed();
}

sub setRasterRepeatsPerformed {
    $_[0]->{_header}->setRasterRepeatsPerformed($_[1]);
}

sub fineMirrorStrainGauge {
    return $_[0]->{_header}->fineMirrorStrainGauge();
}

sub setFineMirrorStrainGauge {
    $_[0]->{_header}->setFineMirrorStrainGauge($_[1]);
}

sub exposuresPerRasterPosition {
    return $_[0]->{_header}->exposuresPerRasterPosition();
}

sub fineMirrorStepSize {
    return $_[0]->{_header}->fineMirrorStepSize();
}

sub header {
    return $_[0]->{_header};
}

sub data {
    return $_[0]->{_data};
}

sub setData {
    $_[0]->populateHeader($_[1]);
}

sub setHeader {
    $_[0]->{_header}->populateHeader($_[1]);
}

sub appendData {
    $_[0]->{_data} .= $_[1];
}

sub tableInfo {
    return $_[0]->{_header}->tableInfo();
}

1;
